<template>
    <div class="content">
        <Header active="login"/>
        <v-card :elevation="4" class="mainContent">
            <h2 class="connectionTitle">{{ $t('connect') }}</h2>
            <v-form ref="login">
                <v-text-field 
                    v-model="id"
                    v-bind:label="$t('username_mail')" 
                    :rules="[rules.required]" 
                    @keyup.enter="submit" 
                    required
                ></v-text-field>
                <v-text-field 
                    v-model="password"
                    v-bind:label="$t('password')" 
                    :rules="[rules.required]" 
                    type="password" 
                    @keyup.enter="submit" 
                    required
                ></v-text-field>
                <p></p>
                <p v-if="error" style="color: red">{{ $t('error_log') }}</p>
                <a @click.stop="openModal">{{ $t('forgotten_password') }}</a>
            </v-form>
            <v-btn absolute right bottom color="primary" @click="submit">{{ $t('login') }}</v-btn>
        </v-card>
        
        <v-dialog v-model="modal" persistent max-width="50vw">
            <Mail @exit="closeModal" />
        </v-dialog>
    </div>
</template>

<script>
    import Header from "@/components/login/Header";
    import Mail from "@/components/login/Mail";
    import APIUser from "@/api/UserAPI.js";

    const apiUser = new APIUser();

    export default {
        name: "App",

        components: {
            Header,
            Mail,
        },

        data () {
            return {
                checkbox: false,
                id: "",
                password: "",
                rules: {
                    required: v => !!v || this.$t("required"),
                },
                error: false,
                modal: false,
            };
        },

        methods: {
            async submit() {
                try {
                    if(this.$refs.login.validate()) {
                        console.log("Submit");
                        let data = await apiUser.login({
                            name: this.id,
                            password: this.password,
                        });
                        this.error = false;
                        let token = data.data.token;
                        localStorage.setItem("user", JSON.stringify(data.data.user));
                        localStorage.setItem("token", JSON.stringify({value: token, expiry: new Date().getTime() + 1000*3600*6}));
                        this.$router.push("/");
                    }
                } catch (err) {
                    this.error = true;
                    console.error(`Error has occured : ${err}`);
                }
            },

            /**
             * Open Modal window
             */
            openModal() {
                this.modal = true;
            },

            /**
             * Close Modal window
             */
            closeModal() {
                this.modal = false;
            },
        },
    };
</script>

<style>
    .mainContent {
        margin-top: 8%;
        margin-left: auto;
        margin-right: auto;
        width: 55%;
        padding: 3%;
        padding-top: 2%;
        font-family: 'Segoe UI';
    }

    .connectionTitle {
        color: #71A0FF;
    }
</style>

<i18n>
{
    "en": {
        "username_mail": "Username / Mail",
        "connect": "Connection",
        "save_password": "Remember my credentials",
        "login": "Login",
        "forgotten_password": "Forgotten password ?",
        "error_log": "Username or password incorrect, please try again"
    },
    "fr": {
        "username_mail": "Nom utilisateur / E-mail",
        "connect": "Connexion",
        "save_password": "Se souvenir de mon mot de passe",
        "login": "Se connecter",
        "forgotten_password": "Mot de passe oublié ?",
        "error_log": "Nom d'utilisateur ou mot de passe incorrect, veuillez réessayer"
    }
}
</i18n>